from backend.core.database import async_session
import backend.exceptions as exceptions
import backend.schemas as schemas
import backend.models as models

import sqlalchemy as sa
import asyncio

import logging
logger = logging.getLogger(__name__)

# = cluster
async def get_cluster(cluster_id: str) -> models.Cluster:
    async with async_session() as db:
        result = await db.execute(
            sa.select(models.Cluster).where(
                models.Cluster.id == cluster_id
            )
        )
        try:
            return result.scalar_one()
        except sa.exc.NoResultFound:
            raise exceptions.ClusterNotFoundException(f"Cluster: {cluster_id}")

async def create_cluster(cluster: schemas.ClusterSchema):
    logger.info(f"should create cluster {cluster.cluster_name}")
    result = ", ".join(f"{k}={v}" for k, v in cluster.model_dump().items())
    logger.info(f"create_kubevirt_cluster({result})")
    
    await asyncio.sleep(20)
    logger.info("cluster created")