from .deps import *

from sqlalchemy.orm import Mapped, mapped_column
import datetime
import uuid

class Flavor(Base):
    __tablename__ = 'flavors'  # This will be the name of the table

    id: Mapped[str] = mapped_column(String(36), primary_key=True, default=lambda: str(uuid.uuid4()))
    name: Mapped[str] = mapped_column(String, nullable=False, unique=True)
    image: Mapped[str] = mapped_column(String, nullable=False)
    cpu: int = Column(Integer, nullable=False)
    memory: Mapped[str] = mapped_column(String, nullable=False)
    creation_time = Column(DateTime, nullable=False, default=datetime.datetime.now(datetime.timezone.utc))  # Auto-filled with UTC time

    def __repr__(self):
        return f"<Flavors(name={self.name}, cpu:{self.cpu}, memory:'{self.memory}', image:'{self.image}', creation_time={self.creation_time})>"