# import backend.schemas as schemas
from .vm.vm import VmSchema, PublicVmSchema
from .id import IdSchema

from pydantic import BaseModel, Field
from typing import List

class NodeInfoSchema(BaseModel):
    vm: VmSchema = Field(..., description="VM configuration")
    control_plane: bool = Field(..., description="Is the node a control-plane")

class PublicClusterSchema(BaseModel):
    cluster_name: str = Field(..., description="Cluster name")
    cluster_type: str = Field("rke2", description="Type of cluster (e.g., rke2, k3s)")
    kubernetes_version: str = Field("v1.31.4+rke2r1", description="Version of kubernetes to install")
    vm_definitions: List[PublicVmSchema]= Field(..., description="List of VMs to compose the cluter")

class ClusterSchema(IdSchema, PublicClusterSchema):
    namespace: str = Field(..., description="Namespace in which to create the VMs")
    vm_definitions: List[VmSchema]= Field(..., description="List of VMs to compose the cluter")